diff -ruN strongswan-5.8.4/src/libcharon/config/ike_cfg.c strongswancont-5.8.4-svc/src/libcharon/config/ike_cfg.c
--- strongswan-5.8.4/src/libcharon/config/ike_cfg.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/config/ike_cfg.c	2023-05-13 16:23:12.316906000 +0300
@@ -119,6 +119,13 @@
 	 * List of proposals to use
 	 */
 	linked_list_t *proposals;
+
+#ifdef _WIN32
+	/**
+	 * should we use block dns?
+	 */
+	bool block_dns;
+#endif /* _WIN32 */
 };
 
 METHOD(ike_cfg_t, get_version, ike_version_t,
@@ -151,6 +158,14 @@
 	return this->childless;
 }
 
+#ifdef _WIN32
+METHOD(ike_cfg_t, block_dns_, bool,
+	private_ike_cfg_t *this)
+{
+	return this->block_dns;
+}
+#endif /* _WIN32 */
+
 /**
  * Common function for resolve_me/other
  */
@@ -603,6 +618,9 @@
 			.select_proposal = _select_proposal,
 			.has_proposal = _has_proposal,
 			.get_dh_group = _get_dh_group,
+#ifdef _WIN32
+			.block_dns = _block_dns_,
+#endif /* _WIN32 */
 			.equals = _equals,
 			.get_ref = _get_ref,
 			.destroy = _destroy,
@@ -623,6 +641,9 @@
 		.other_port = data->remote_port,
 		.dscp = data->dscp,
 		.proposals = linked_list_create(),
+#ifdef _WIN32
+		.block_dns = data->block_dns,
+#endif /* _WIN32 */
 	);
 
 	parse_addresses(data->local, this->my_hosts, this->my_ranges);
diff -ruN strongswan-5.8.4/src/libcharon/config/ike_cfg.h strongswancont-5.8.4-svc/src/libcharon/config/ike_cfg.h
--- strongswan-5.8.4/src/libcharon/config/ike_cfg.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/config/ike_cfg.h	2023-05-13 16:24:21.778641000 +0300
@@ -236,6 +236,15 @@
 	 */
 	diffie_hellman_group_t (*get_dh_group)(ike_cfg_t *this);
 
+#ifdef _WIN32
+	/**
+	 * Should we use block DNS?
+	 *
+	 * @return				TRUE to block DNS
+	 */
+	bool (*block_dns) (ike_cfg_t *this);
+#endif /* _WIN32 */
+
 	/**
 	 * Check if two IKE configs are equal.
 	 *
@@ -289,6 +298,10 @@
 	childless_t childless;
 	/** DSCP value to send IKE packets with */
 	uint8_t dscp;
+#ifdef _WIN32
+	/** TRUE to use block DNS */
+	bool block_dns;
+#endif /* _WIN32 */
 };
 
 /**
diff -ruN strongswan-5.8.4/src/libcharon/encoding/payloads/certreq_payload.c strongswancont-5.8.4-svc/src/libcharon/encoding/payloads/certreq_payload.c
--- strongswan-5.8.4/src/libcharon/encoding/payloads/certreq_payload.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/encoding/payloads/certreq_payload.c	2022-07-06 15:47:33.830968000 +0300
@@ -116,9 +116,9 @@
 	{
 		if (this->data.len % HASH_SIZE_SHA1)
 		{
-			DBG1(DBG_ENC, "invalid X509 hash length (%d) in certreq",
+			DBG1(DBG_ENC, "unknown X509 hash length (%d) in certreq",
 				 this->data.len);
-			return FAILED;
+			return SUCCESS;
 		}
 	}
 	return SUCCESS;
diff -ruN strongswan-5.8.4/src/libcharon/encoding/payloads/proposal_substructure.c strongswancont-5.8.4-svc/src/libcharon/encoding/payloads/proposal_substructure.c
--- strongswan-5.8.4/src/libcharon/encoding/payloads/proposal_substructure.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/encoding/payloads/proposal_substructure.c	2022-07-06 15:47:33.834968000 +0300
@@ -174,6 +174,12 @@
 	/* FreeS/WAN proprietary */
 	IKEV1_ENCR_SERPENT_CBC = 65004,
 	IKEV1_ENCR_TWOFISH_CBC = 65005,
+	/* BY specific */
+	IKEV1_ENCR_GOST28147_CFB = 65530,
+	IKEV1_ENCR_GOST28147_CTR = 65531,
+	IKEV1_ENCR_BELT_CFB = 65532,
+	IKEV1_ENCR_BELT_CBC = 65533,
+	IKEV1_ENCR_BELT_CTR = 65534,
 } ikev1_encryption_t;
 
 /**
@@ -186,6 +192,11 @@
 	IKEV1_HASH_SHA2_256 = 4,
 	IKEV1_HASH_SHA2_384 = 5,
 	IKEV1_HASH_SHA2_512 = 6,
+	/* BY specific */
+	IKEV1_GOST_MAC = 65529,
+	IKEV1_BELT_MAC = 65530,
+	IKEV1_BELT_HMAC = 65531,
+	IKEV1_BELT_HASH = 65532,
 } ikev1_hash_t;
 
 /**
@@ -222,8 +233,14 @@
 	IKEV1_ESP_ENCR_CAMELLIA = 22,
 	IKEV1_ESP_ENCR_NULL_AUTH_AES_GMAC = 23,
 	/* FreeS/WAN proprietary */
-	IKEV1_ESP_ENCR_SERPENT = 252,
+	IKEV1_ESP_ENCR_SERPENT = 251,
 	IKEV1_ESP_ENCR_TWOFISH = 253,
+	/* BY specific */
+	IKEV1_ESP_ENCR_GOST28147_CTR = 249,
+	IKEV1_ESP_ENCR_GOST28147_CFB = 250,
+	IKEV1_ESP_ENCR_BELT_CFB = 252,
+	IKEV1_ESP_ENCR_BELT_CBC = 254,
+	IKEV1_ESP_ENCR_BELT_CTR = 255,
 } ikev1_esp_transid_t;
 
 /**
@@ -242,6 +259,11 @@
 	IKEV1_AH_AES_128_GMAC = 11,
 	IKEV1_AH_AES_192_GMAC = 12,
 	IKEV1_AH_AES_256_GMAC = 13,
+	/* BY specific */
+	IKEV1_AH_GOST_MAC = 65531,
+	IKEV1_AH_BELT_MAC = 65532,
+	IKEV1_AH_BELT_HMAC = 65533,
+	IKEV1_AH_BELT_HASH = 65534,
 } ikev1_ah_transid_t;
 
 /**
@@ -261,6 +283,11 @@
 	IKEV1_AUTH_AES_128_GMAC = 11,
 	IKEV1_AUTH_AES_192_GMAC = 12,
 	IKEV1_AUTH_AES_256_GMAC = 13,
+	/* BY specific */
+	IKEV1_ESP_AUTH_GOST_MAC = 65531,
+	IKEV1_ESP_AUTH_BELT_MAC = 65532,
+	IKEV1_ESP_AUTH_BELT_HMAC = 65533,
+	IKEV1_ESP_AUTH_BELT_HASH = 65534,
 } ikev1_auth_algo_t;
 
 /**
@@ -311,6 +338,8 @@
 	IKEV1_AUTH_HYBRID_RESP_RSA = 64222,
 	IKEV1_AUTH_HYBRID_INIT_DSS = 64223,
 	IKEV1_AUTH_HYBRID_RESP_DSS = 64224,
+	/* BIGN */
+	IKEV1_AUTH_BIGN = 65201,
 } ikev1_auth_method_t;
 
 /**
@@ -591,6 +620,11 @@
 	{ IKEV1_ENCR_CAST_CBC,		ENCR_CAST },
 	{ IKEV1_ENCR_AES_CBC,		ENCR_AES_CBC },
 	{ IKEV1_ENCR_CAMELLIA_CBC,	ENCR_CAMELLIA_CBC },
+	{ IKEV1_ENCR_GOST28147_CTR,	ENCR_GOST28147_CTR },
+	{ IKEV1_ENCR_GOST28147_CFB,	ENCR_GOST28147_CFB },
+	{ IKEV1_ENCR_BELT_CBC,		ENCR_BELT_CBC },
+	{ IKEV1_ENCR_BELT_CFB,		ENCR_BELT_CFB },
+	{ IKEV1_ENCR_BELT_CTR,		ENCR_BELT_CTR },
 	{ IKEV1_ENCR_SERPENT_CBC,	ENCR_SERPENT_CBC },
 	{ IKEV1_ENCR_TWOFISH_CBC,	ENCR_TWOFISH_CBC },
 };
@@ -604,6 +638,10 @@
 	{ IKEV1_HASH_SHA2_256,		AUTH_HMAC_SHA2_256_128 },
 	{ IKEV1_HASH_SHA2_384,		AUTH_HMAC_SHA2_384_192 },
 	{ IKEV1_HASH_SHA2_512,		AUTH_HMAC_SHA2_512_256 },
+	{ IKEV1_BELT_HASH,			AUTH_BELT_HASH },
+	{ IKEV1_GOST_MAC,			AUTH_GOST_MAC },
+	{ IKEV1_BELT_MAC,			AUTH_BELT_MAC },
+	{ IKEV1_BELT_HMAC,			AUTH_BELT_HMAC },
 };
 
 /**
@@ -615,6 +653,7 @@
 	{ IKEV1_HASH_SHA2_256,		PRF_HMAC_SHA2_256 },
 	{ IKEV1_HASH_SHA2_384,		PRF_HMAC_SHA2_384 },
 	{ IKEV1_HASH_SHA2_512,		PRF_HMAC_SHA2_512 },
+	{ IKEV1_BELT_HASH,			PRF_HMAC_HBELT }
 };
 
 /**
@@ -641,6 +680,11 @@
 	{ IKEV1_ESP_ENCR_AES_GCM_16,			ENCR_AES_GCM_ICV16 },
 	{ IKEV1_ESP_ENCR_CAMELLIA,				ENCR_CAMELLIA_CBC },
 	{ IKEV1_ESP_ENCR_NULL_AUTH_AES_GMAC,	ENCR_NULL_AUTH_AES_GMAC },
+	{ IKEV1_ESP_ENCR_GOST28147_CTR,			ENCR_GOST28147_CTR },
+	{ IKEV1_ESP_ENCR_GOST28147_CFB,			ENCR_GOST28147_CFB },
+	{ IKEV1_ESP_ENCR_BELT_CBC,				ENCR_BELT_CBC },
+	{ IKEV1_ESP_ENCR_BELT_CFB,				ENCR_BELT_CFB },
+	{ IKEV1_ESP_ENCR_BELT_CTR,				ENCR_BELT_CTR },
 	{ IKEV1_ESP_ENCR_SERPENT,				ENCR_SERPENT_CBC },
 	{ IKEV1_ESP_ENCR_TWOFISH,				ENCR_TWOFISH_CBC },
 };
@@ -659,6 +703,10 @@
 	{ IKEV1_AH_AES_128_GMAC,	AUTH_AES_128_GMAC },
 	{ IKEV1_AH_AES_192_GMAC,	AUTH_AES_192_GMAC },
 	{ IKEV1_AH_AES_256_GMAC,	AUTH_AES_256_GMAC },
+	{ IKEV1_AH_BELT_HASH,		AUTH_BELT_HASH },
+	{ IKEV1_AH_GOST_MAC,		AUTH_GOST_MAC },
+	{ IKEV1_AH_BELT_MAC,		AUTH_BELT_MAC },
+	{ IKEV1_AH_BELT_HMAC,		AUTH_BELT_HMAC },
 };
 
 /**
@@ -676,6 +724,10 @@
 	{ IKEV1_AUTH_AES_128_GMAC,		AUTH_AES_128_GMAC },
 	{ IKEV1_AUTH_AES_192_GMAC,		AUTH_AES_192_GMAC },
 	{ IKEV1_AUTH_AES_256_GMAC,		AUTH_AES_256_GMAC },
+	{ IKEV1_ESP_AUTH_BELT_HASH,		AUTH_BELT_HASH },
+	{ IKEV1_ESP_AUTH_GOST_MAC,		AUTH_GOST_MAC },
+	{ IKEV1_ESP_AUTH_BELT_MAC,		AUTH_BELT_MAC },
+	{ IKEV1_ESP_AUTH_BELT_HMAC,		AUTH_BELT_HMAC },
 };
 
 /**
@@ -833,6 +885,8 @@
 			return IKEV1_AUTH_ECDSA_384;
 		case AUTH_ECDSA_521:
 			return IKEV1_AUTH_ECDSA_521;
+		case AUTH_BIGN:
+			return IKEV1_AUTH_BIGN;
 		case AUTH_PSK:
 		default:
 			return IKEV1_AUTH_PSK;
@@ -1186,6 +1240,8 @@
 			return AUTH_ECDSA_384;
 		case IKEV1_AUTH_ECDSA_521:
 			return AUTH_ECDSA_521;
+		case IKEV1_AUTH_BIGN:
+			return AUTH_BIGN;
 		default:
 			return AUTH_NONE;
 	}
@@ -1506,6 +1562,16 @@
 		add_transform_substructure(this, transform);
 	}
 	enumerator->destroy(enumerator);
+
+	/* key transform algorithms (keyrep) */
+	enumerator = proposal->create_enumerator(proposal, KEY_TRANSFORM_ALGORITHM);
+	while (enumerator->enumerate(enumerator, &alg, NULL))
+	{
+		transform = transform_substructure_create_type(PLV2_TRANSFORM_SUBSTRUCTURE,
+												KEY_TRANSFORM_ALGORITHM, alg);
+		add_transform_substructure(this, transform);
+	}
+	enumerator->destroy(enumerator);
 }
 
 /**
diff -ruN strongswan-5.8.4/src/libcharon/plugins/eap_gtc/eap_gtc.c strongswancont-5.8.4-svc/src/libcharon/plugins/eap_gtc/eap_gtc.c
--- strongswan-5.8.4/src/libcharon/plugins/eap_gtc/eap_gtc.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/eap_gtc/eap_gtc.c	2022-07-06 15:47:33.850968000 +0300
@@ -195,7 +195,7 @@
 METHOD(eap_method_t, get_msk, status_t,
 	private_eap_gtc_t *this, chunk_t *msk)
 {
-	return FAILED;
+	return NOT_SUPPORTED;
 }
 
 METHOD(eap_method_t, get_identifier, uint8_t,
diff -ruN strongswan-5.8.4/src/libcharon/plugins/eap_md5/eap_md5.c strongswancont-5.8.4-svc/src/libcharon/plugins/eap_md5/eap_md5.c
--- strongswan-5.8.4/src/libcharon/plugins/eap_md5/eap_md5.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/eap_md5/eap_md5.c	2022-07-06 15:47:33.866969000 +0300
@@ -213,7 +213,7 @@
 METHOD(eap_method_t, get_msk, status_t,
 	private_eap_md5_t *this, chunk_t *msk)
 {
-	return FAILED;
+	return NOT_SUPPORTED;
 }
 
 METHOD(eap_method_t, is_mutual, bool,
diff -ruN strongswan-5.8.4/src/libcharon/plugins/eap_radius/eap_radius.c strongswancont-5.8.4-svc/src/libcharon/plugins/eap_radius/eap_radius.c
--- strongswan-5.8.4/src/libcharon/plugins/eap_radius/eap_radius.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/eap_radius/eap_radius.c	2022-07-06 15:47:33.874969000 +0300
@@ -733,7 +733,9 @@
 		*out = msk;
 		return SUCCESS;
 	}
-	return FAILED;
+	/* we assume the selected method did not establish an MSK, if it failed
+	 * to establish one, process() would have failed */
+	return NOT_SUPPORTED;
 }
 
 METHOD(eap_method_t, get_identifier, uint8_t,
diff -ruN strongswan-5.8.4/src/libcharon/plugins/kernel_iph/kernel_iph_net.c strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_iph/kernel_iph_net.c
--- strongswan-5.8.4/src/libcharon/plugins/kernel_iph/kernel_iph_net.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_iph/kernel_iph_net.c	2023-06-15 15:40:59.955019000 +0300
@@ -77,6 +77,26 @@
 };
 
 /**
+ * Interface address entry
+ */
+typedef struct {
+	/** address */
+	host_t *ip;
+	/** is virtual installed by us? */
+	bool virtual;
+} addr_t;
+
+/**
+ * Clean up an addr_t
+ */
+CALLBACK(addr_destroy, void,
+	addr_t *this)
+{
+	this->ip->destroy(this->ip);
+	free(this);
+}
+
+/**
  * Interface entry
  */
 typedef struct  {
@@ -99,7 +119,7 @@
  */
 static void iface_destroy(iface_t *this)
 {
-	this->addrs->destroy_offset(this->addrs, offsetof(host_t, destroy));
+	this->addrs->destroy_function(this->addrs, addr_destroy);
 	free(this->ifname);
 	free(this->ifdesc);
 	free(this);
@@ -155,6 +175,70 @@
 }
 
 /**
+ * Add an address entry to a named interface, return ifindex
+ */
+static DWORD add_addr(private_kernel_iph_net_t *this, char *name, host_t *ip,
+					  bool virtual)
+{
+	enumerator_t *enumerator;
+	addr_t *addr;
+	iface_t *iface;
+	DWORD ifindex = 0;
+
+	this->mutex->lock(this->mutex);
+	enumerator = this->ifaces->create_enumerator(this->ifaces);
+	while (enumerator->enumerate(enumerator, &iface))
+	{
+		if (streq(name, iface->ifname))
+		{
+			INIT(addr,
+				.ip = ip->clone(ip),
+				.virtual = virtual,
+			);
+			iface->addrs->insert_last(iface->addrs, addr);
+			ifindex = iface->ifindex;
+			break;
+		}
+	}
+	enumerator->destroy(enumerator);
+	this->mutex->unlock(this->mutex);
+
+	return ifindex;
+}
+
+/**
+ * Remove address entry from named interface, return ifindex
+ */
+static DWORD remove_addr(private_kernel_iph_net_t *this, host_t *ip)
+{
+	enumerator_t *ifaces, *addrs;
+	iface_t *iface;
+	addr_t *addr;
+	DWORD ifindex = 0;
+
+	this->mutex->lock(this->mutex);
+	ifaces = this->ifaces->create_enumerator(this->ifaces);
+	while (!ifindex && ifaces->enumerate(ifaces, &iface))
+	{
+		addrs = iface->addrs->create_enumerator(iface->addrs);
+		while (!ifindex && addrs->enumerate(addrs, &addr))
+		{
+			if (ip->ip_equals(ip, addr->ip))
+			{
+				iface->addrs->remove_at(iface->addrs, addrs);
+				addr_destroy(addr);
+				ifindex = iface->ifindex;
+			}
+		}
+		addrs->destroy(addrs);
+	}
+	ifaces->destroy(ifaces);
+	this->mutex->unlock(this->mutex);
+
+	return ifindex;
+}
+
+/**
  * Update addresses for an iface entry
  */
 static void update_addrs(private_kernel_iph_net_t *this, iface_t *entry,
@@ -163,7 +247,8 @@
 	IP_ADAPTER_UNICAST_ADDRESS *current;
 	enumerator_t *enumerator;
 	linked_list_t *list;
-	host_t *host, *old;
+	host_t *host;
+	addr_t *aentry;
 	bool changes = FALSE;
 
 	list = entry->addrs;
@@ -185,21 +270,27 @@
 		host = host_create_from_sockaddr(current->Address.lpSockaddr);
 		if (host)
 		{
-			bool found = FALSE;
+			addr_t *found = FALSE;
 
 			enumerator = list->create_enumerator(list);
-			while (enumerator->enumerate(enumerator, &old))
+			while (enumerator->enumerate(enumerator, &aentry))
 			{
-				if (host->ip_equals(host, old))
+				if (host->ip_equals(host, aentry->ip))
 				{
 					list->remove_at(list, enumerator);
-					old->destroy(old);
-					found = TRUE;
+					found = aentry;
+					break;
 				}
 			}
 			enumerator->destroy(enumerator);
 
-			entry->addrs->insert_last(entry->addrs, host);
+			if (!found)
+			{
+				INIT(found,
+					.ip = host->clone(host),
+				);
+			}
+			entry->addrs->insert_last(entry->addrs, found);
 
 			if (!found && log)
 			{
@@ -207,18 +298,19 @@
 					 host, entry->ifindex, entry->ifdesc);
 				changes = TRUE;
 			}
+			host->destroy(host);
 		}
 	}
 
-	while (list->remove_first(list, (void**)&old) == SUCCESS)
+	while (list->remove_first(list, (void**)&aentry) == SUCCESS)
 	{
 		if (log)
 		{
 			DBG1(DBG_KNL, "%H disappeared from interface %u '%s'",
-				 old, entry->ifindex, entry->ifdesc);
+				 aentry->ip, entry->ifindex, entry->ifdesc);
 			changes = TRUE;
 		}
-		old->destroy(old);
+		addr_destroy(aentry);
 	}
 	list->destroy(list);
 
@@ -362,6 +454,8 @@
 	MIB_IPINTERFACE_ROW_FIXUP* row = (MIB_IPINTERFACE_ROW_FIXUP*)row_badal;
 	IP_ADAPTER_ADDRESSES addrs[64], *current;
 	ULONG res, size = sizeof(addrs);
+	char buf[512];
+	DBG1(DBG_KNL, "Received NotifyIpInterfaceChange callback");
 
 	if (row && type == MibDeleteInstance)
 	{
@@ -401,7 +495,7 @@
 		}
 		else
 		{
-			DBG1(DBG_KNL, "getting IPH adapter addresses failed: 0x%08lx", res);
+			DBG1(DBG_KNL, "getting IPH adapter addresses failed: 0x%08lx (%s)", res, human_readable_error(buf, res, sizeof(buf)));
 		}
 	}
 }
@@ -413,15 +507,15 @@
 {
 	enumerator_t *ifaces, *addrs;
 	iface_t *entry, *found = NULL;
-	host_t *host;
+	addr_t *addr;
 
 	ifaces = this->ifaces->create_enumerator(this->ifaces);
 	while (!found && ifaces->enumerate(ifaces, &entry))
 	{
 		addrs = entry->addrs->create_enumerator(entry->addrs);
-		while (!found && addrs->enumerate(addrs, &host))
+		while (!found && addrs->enumerate(addrs, &addr))
 		{
-			if (host->ip_equals(host, ip))
+			if (ip->ip_equals(ip, addr->ip))
 			{
 				found = entry;
 			}
@@ -433,6 +527,31 @@
 	return found;
 }
 
+/**
+ * Find an interface index by interface name
+ */
+static DWORD ifname2index(private_kernel_iph_net_t *this, char *name)
+{
+	enumerator_t *enumerator;
+	iface_t *entry;
+	DWORD ifindex = 0;
+
+	this->mutex->lock(this->mutex);
+	enumerator = this->ifaces->create_enumerator(this->ifaces);
+	while (enumerator->enumerate(enumerator, &entry))
+	{
+		if (streq(name, entry->ifname))
+		{
+			ifindex = entry->ifindex;
+			break;
+		}
+	}
+	enumerator->destroy(enumerator);
+	this->mutex->unlock(this->mutex);
+
+	return ifindex;
+}
+
 METHOD(kernel_net_t, get_interface_name, bool,
 	private_kernel_iph_net_t *this, host_t* ip, char **name)
 {
@@ -466,12 +585,10 @@
 } addr_enumerator_t;
 
 METHOD(enumerator_t, addr_enumerate, bool,
-	addr_enumerator_t *this, va_list args)
+	addr_enumerator_t *this, host_t **host)
 {
 	iface_t *entry;
-	host_t **host;
-
-	VA_ARGS_VGET(args, host);
+	addr_t *addr;
 
 	while (TRUE)
 	{
@@ -493,8 +610,13 @@
 			}
 			this->addrs = entry->addrs->create_enumerator(entry->addrs);
 		}
-		if (this->addrs->enumerate(this->addrs, host))
+		if (this->addrs->enumerate(this->addrs, &addr))
 		{
+			if (addr->virtual && (this->which & ADDR_TYPE_REGULAR))
+			{
+				continue;
+			}
+			*host = addr->ip;
 			return TRUE;
 		}
 		this->addrs->destroy(this->addrs);
@@ -502,7 +624,7 @@
 	}
 }
 
-METHOD(enumerator_t, addr_destroy, void,
+METHOD(enumerator_t, addr_enumerator_destroy, void,
 	addr_enumerator_t *this)
 {
 	DESTROY_IF(this->addrs);
@@ -516,19 +638,12 @@
 {
 	addr_enumerator_t *enumerator;
 
-	if (!(which & ADDR_TYPE_REGULAR))
-	{
-		/* we currently have no virtual, but regular IPs only */
-		return enumerator_create_empty();
-	}
-
 	this->mutex->lock(this->mutex);
 
 	INIT(enumerator,
 		.public = {
-			.enumerate = enumerator_enumerate_default,
-			.venumerate = _addr_enumerate,
-			.destroy = _addr_destroy,
+			.enumerate = (void*)_addr_enumerate,
+			.destroy = _addr_enumerator_destroy,
 		},
 		.which = which,
 		.ifaces = this->ifaces->create_enumerator(this->ifaces),
@@ -608,18 +723,104 @@
 	return NULL;
 }
 
+/**
+ * Create a MIB unicast row from a host
+ */
+static void host2unicast(host_t *host, int prefix, MIB_UNICASTIPADDRESS_ROW *row)
+{
+	InitializeUnicastIpAddressEntry(row);
+
+	row->Address.si_family = host->get_family(host);
+	memcpy(&row->Address, host->get_sockaddr(host),
+		   *host->get_sockaddr_len(host));
+
+	row->PrefixOrigin = IpPrefixOriginOther;
+	row->SuffixOrigin = IpSuffixOriginOther;
+	/* don't change the default route to this address */
+	row->SkipAsSource = FALSE;
+	if (prefix == -1)
+	{
+		if (row->Address.si_family == AF_INET)
+		{
+			row->OnLinkPrefixLength = 32;
+		}
+		else
+		{
+			row->OnLinkPrefixLength = 128;
+		}
+	}
+	else
+	{
+		row->OnLinkPrefixLength = prefix;
+	}
+}
+
 METHOD(kernel_net_t, add_ip, status_t,
-	private_kernel_iph_net_t *this, host_t *virtual_ip, int prefix,
-	char *iface_name)
+	private_kernel_iph_net_t *this, host_t *vip, int prefix, char *name)
 {
-	return NOT_SUPPORTED;
+	char buf[512];
+	MIB_UNICASTIPADDRESS_ROW row;
+	u_long status;
+
+	/* name of the MS Loopback adapter */
+	// name = "{DB2C49B1-7C90-4253-9E61-8C6A881194ED}";
+
+	if (!lib->settings->get_bool(lib->settings,
+					"%s.install_virtual_ip", TRUE, lib->ns)) {
+		return FAILED;
+	}
+
+	char *install_virtual_ip_on = lib->settings->get_str(lib->settings,
+					"%s.install_virtual_ip_on", NULL, lib->ns);
+
+	if (install_virtual_ip_on) {
+		name = install_virtual_ip_on;
+	}
+	host2unicast(vip, prefix, &row);
+
+	row.InterfaceIndex = add_addr(this, name, vip, TRUE);
+	if (!row.InterfaceIndex)
+	{
+		DBG1(DBG_KNL, "interface '%s' not found", name);
+		return NOT_FOUND;
+	}
+
+	status = CreateUnicastIpAddressEntry(&row);
+	if (status != NO_ERROR)
+	{
+		DBG1(DBG_KNL, "creating IPH address entry failed: %lu (%s)", status,
+			human_readable_error(buf, status, sizeof(buf)));
+		remove_addr(this, vip);
+		return FAILED;
+	}
+	return SUCCESS;
 }
 
 METHOD(kernel_net_t, del_ip, status_t,
-	private_kernel_iph_net_t *this, host_t *virtual_ip, int prefix,
-	bool wait)
+	private_kernel_iph_net_t *this, host_t *vip, int prefix, bool wait)
 {
-	return NOT_SUPPORTED;
+	char buf[512];
+	MIB_UNICASTIPADDRESS_ROW row;
+	u_long status;
+
+	host2unicast(vip, prefix, &row);
+
+	row.InterfaceIndex = remove_addr(this, vip);
+	if (!row.InterfaceIndex)
+	{
+		DBG1(DBG_KNL, "virtual IP %H not found", vip);
+		return NOT_FOUND;
+	}
+
+	status = DeleteUnicastIpAddressEntry(&row);
+	if (status != NO_ERROR)
+	{
+		DBG1(DBG_KNL, "deleting IPH address entry failed: %lu (%s)", status,
+			human_readable_error(buf, status, sizeof(buf)));
+		return FAILED;
+	}
+
+	return SUCCESS;
 }
 
 /**
@@ -628,6 +829,7 @@
 static status_t manage_route(private_kernel_iph_net_t *this, bool add,
 					chunk_t dst, uint8_t prefixlen, host_t *gtw, char *name)
 {
+	char buf[512];
 	MIB_IPFORWARD_ROW2 row = {
 		.DestinationPrefix = {
 			.PrefixLength = prefixlen,
@@ -638,23 +840,30 @@
 		.Metric = 10,
 		.Protocol = MIB_IPPROTO_NETMGMT,
 	};
-	enumerator_t *enumerator;
-	iface_t *entry;
 	ULONG ret;
 
-	this->mutex->lock(this->mutex);
-	enumerator = this->ifaces->create_enumerator(this->ifaces);
-	while (enumerator->enumerate(enumerator, &entry))
+	/* if route is 0.0.0.0/0, we can't install it, as it would
+	 * overwrite the default route. Instead, we add two routes:
+	 * 0.0.0.0/1 and 128.0.0.0/1 */
+	if (prefixlen == 0)
 	{
-		if (streq(name, entry->ifname))
+		chunk_t half;
+		status_t status;
+
+		half = chunk_alloca(dst.len);
+		memset(half.ptr, 0, half.len);
+		prefixlen = 1;
+
+		status = manage_route(this, add, half, prefixlen, gtw, name);
+		if (status == SUCCESS)
 		{
-			row.InterfaceIndex = entry->ifindex;
-			break;
+			half.ptr[0] |= 0x80;
+			status = manage_route(this, add, half, prefixlen, gtw, name);
 		}
+		return status;
 	}
-	enumerator->destroy(enumerator);
-	this->mutex->unlock(this->mutex);
 
+	row.InterfaceIndex = ifname2index(this, name);
 	if (!row.InterfaceIndex)
 	{
 		return NOT_FOUND;
@@ -690,7 +899,8 @@
 	}
 	if (ret != NO_ERROR)
 	{
-		DBG1(DBG_KNL, "%sing route failed: 0x%08lx", add ? "add" : "remov", ret);
+		DBG1(DBG_KNL, "%sing route failed: 0x%08lx (%s)", add ? "add" : "remov", ret,
+			human_readable_error(buf, ret, sizeof(buf)));
 		return FAILED;
 	}
 
@@ -699,7 +909,8 @@
 		ret = EnableRouter(NULL, &this->router);
 		if (ret != ERROR_IO_PENDING)
 		{
-			DBG1(DBG_KNL, "EnableRouter router failed: 0x%08lx", ret);
+			DBG1(DBG_KNL, "EnableRouter router failed: 0x%08lx (%s)", ret,
+				human_readable_error(buf, ret, sizeof(buf)));
 		}
 	}
 	else
@@ -707,7 +918,8 @@
 		ret = UnenableRouter(&this->router, NULL);
 		if (ret != NO_ERROR)
 		{
-			DBG1(DBG_KNL, "UnenableRouter router failed: 0x%08lx", ret);
+			DBG1(DBG_KNL, "UnenableRouter router failed: 0x%08lx (%s)", ret, 
+				human_readable_error(buf, ret, sizeof(buf)));
 		}
 	}
 	return SUCCESS;
@@ -748,6 +960,8 @@
 	private_kernel_iph_net_t *this;
 	ULONG res;
 
+	char buf[512];
+
 	INIT(this,
 		.public = {
 			.interface = {
@@ -774,8 +988,8 @@
 								  this, TRUE, &this->changes);
 	if (res != NO_ERROR)
 	{
-		DBG1(DBG_KNL, "registering for IPH interface changes failed: 0x%08lx",
-			 res);
+		DBG1(DBG_KNL, "registering for IPH interface changes failed: 0x%08lx (%s)",
+			 res, human_readable_error(buf, res, sizeof(buf)));
 		destroy(this);
 		return NULL;
 	}
diff -ruN strongswan-5.8.4/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_plugin.c strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_plugin.c
--- strongswan-5.8.4/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_plugin.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/kernel_libipsec/kernel_libipsec_plugin.c	2022-07-08 11:03:52.756696000 +0300
@@ -19,8 +19,11 @@
 
 #include <daemon.h>
 #include <ipsec.h>
+#ifdef WIN32
+#include <networking/windows_tun.h>
+#else
 #include <networking/tun_device.h>
-
+#endif
 #define TUN_DEFAULT_MTU 1400
 
 typedef struct private_kernel_libipsec_plugin_t private_kernel_libipsec_plugin_t;
@@ -95,12 +98,23 @@
 	free(this);
 }
 
+#ifdef WIN32
+METHOD(plugin_t, reload, bool,
+	private_kernel_libipsec_plugin_t *this)
+{
+	this->router->reload(this->router);
+	return TRUE;
+}
+#endif
+
 /*
  * see header file
  */
 plugin_t *kernel_libipsec_plugin_create()
 {
 	private_kernel_libipsec_plugin_t *this;
+	char buf[512];
+	HANDLE pseudohandle = GetCurrentProcess();
 
 	if (!lib->caps->check(lib->caps, CAP_NET_ADMIN))
 	{	/* required to create TUN devices */
@@ -115,6 +129,9 @@
 				.get_name = _get_name,
 				.get_features = _get_features,
 				.destroy = _destroy,
+#ifdef WIN32
+				.reload = _reload,
+#endif
 			},
 		},
 	);
@@ -130,6 +147,17 @@
 	if (!this->tun)
 	{
 		DBG1(DBG_KNL, "failed to create TUN device");
+		if (lib->settings->get_bool(lib->settings, "%s.use_wintun", FALSE,
+					 lib->ns))
+		{
+			/** Windows is incredibly wonky and a lot of memory allocation
+			 * goes wrong is anything goes wrong in setupapi when setting up wintun
+			 * so we need to bail out here and stop the whole process.
+			 * It's pointless to try to continue because the event handler won't be
+			 * set up properly (queue will not be allocated, lock will be a NULL pointer, ...)
+			 */
+			charon->bus->alert(charon->bus, ALERT_SHUTDOWN_SIGNAL);
+		}		
 		destroy(this);
 		return NULL;
 	}
@@ -145,5 +173,14 @@
 	/* set TUN device as default to install VIPs */
 	lib->settings->set_str(lib->settings, "%s.install_virtual_ip_on",
 						   this->tun->get_name(this->tun), lib->ns);
+	
+	/* Need highest priority (not realtime for now) 
+	 * to make sure strongSwan can always process packets */
+	if(!SetPriorityClass(pseudohandle, HIGH_PRIORITY_CLASS))
+	{
+		DBG1(DBG_LIB, "Failed to raise process priority: %s", dlerror_mt(buf, sizeof(buf)));
+	} else {
+		DBG1(DBG_LIB, "Raised process priority to HIGH_PRIORITY_CLASS");
+	}	
 	return &this->public.plugin;
 }
